﻿using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace CSHowDoISamples
{
    public partial class DisplayASimpleMap : UserControl
    {
        public DisplayASimpleMap()
        {
            InitializeComponent();
        }

        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;
            Map1.CurrentExtent = new RectangleShape(-180.0, 83.0, -20.0, -20.0);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\SampleData\Data\Countries02.shp");
            worldLayer.Name = "Countries02";
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(worldLayer);

            Map1.Overlays.Add(overlay);

            Map1.Refresh();
        }

        private void btnTest_Click(object sender, RoutedEventArgs e)
        {
            ShapeFileFeatureLayer layer = (Map1.Overlays[0] as LayerOverlay).Layers[0] as ShapeFileFeatureLayer;

            if (!layer.IsOpen)
            {
                layer.Open();
            }

            Collection<Feature> features = layer.QueryTools.GetFeaturesNearestTo(new PointShape(20, -40), GeographyUnit.DecimalDegree, 5, ReturningColumnsType.AllColumns);
            resultLabel.Text = features.Count.ToString();

            Map1.CenterAt(new PointShape(20, -40));
            Map1.Refresh();
        }
    }
}